#ifndef _common_h_
#define _common_h_

#include "..\XOBJECT\xobject.h"
#include "..\XOBJFLD\xobjfld.h"
#include "..\XINTFLD\xintfld.h"
#include "..\XDBLFLD\xdblfld.h"
#include "..\XSTRFLD\xstrfld.h"
#include "..\XTXTFLD\xtxtfld.h"
#include "..\XRDTFLD\xrdtfld.h"
#include "..\XCMTFLD\xcmtfld.h"
#include "..\XREFFLD\xreffld.h"
#include "..\XCLMFLD\xclmfld.h"

#define LOG XObject::log
#define LOGOBJ XObject::logObject
#define LOGCLASSES() XObject::logClasses()

#define AMT_COPYRIGHT	"(C)1994-%d, AMT, "
#define AMT_PATH	"AMT_PATH"
#define AMT_CONFIG	"config.ini"
#define AMT_CONFIG_CLASSES	"classes"
#define AMT_CONFIG_LOGLEVEL	"loglevel"
#define AMT_CONFIG_CUSTOMER	"customer"
#define AMT_OBJECT_PAGES	"pages"
#define AMT_OBJECT_SECTIONS	"sections"
#define AMT_OBJECT_TITLE	"title"
#define AMT_OBJECT_TYPE		"type"
#define AMT_STUDENT_LESSONS	"lessons"
#define AMT_STUDENT_MAXLESSONS	"maxlessons"

#define WM_AMTINIT	(WM_USER + 1)
#define ID_AMTUNDO	500
#define ID_AMTDEFAULT	501
#define ID_AMTHELP	502
#define ID_AMTREFRESH	503
#define ID_AMTINIT	504

#define CLASS_INTFIELD_NAME		"IntField"
#define CLASS_DOUBLEFIELD_NAME		"DoubleField"
#define CLASS_STRINGFIELD_NAME		"StringField"
#define CLASS_TEXTFIELD_NAME		"TextField"
#define CLASS_REFERENCEFIELD_NAME	"ReferenceField"
#define CLASS_RADIOTOGGLEFIELD_NAME	"RadioToggleField"
#define CLASS_COMBOTOGGLEFIELD_NAME	"ComboToggleField"
#define CLASS_COLORMASKFIELD_NAME	"ColorMaskField"
#define CLASS_ROCKLISTFIELD_NAME	"RockListField"
#define CLASS_LAYERLISTFIELD_NAME	"LayerListField"
#define CLASS_ALARMLISTFIELD_NAME	"AlarmListField"

#define Box(title, text)	\
	WinMessageBox(HWND_DESKTOP, HWND_DESKTOP, (PSZ) text, (PSZ) title, 20, \
	MB_APPLMODAL | MB_OK | MB_INFORMATION | MB_MOVEABLE)

#define XOBJECT_INITIALIZE			\
	{					\
		XObject::initClass();		\
		XIntField::initClass();		\
		XDoubleField::initClass();	\
		XStringField::initClass();	\
		XTextField::initClass();	\
		XRadioToggleField::initClass();	\
		XComboToggleField::initClass();	\
		XReferenceField::initClass();	\
		XColorMaskField::initClass();	\
	}					\

#define XOBJECT_UNINITIALIZE			\
	{					\
		XObject::unInitClass();		\
	}					\

#define AMTWPS_MECH	"DRM_AMTWPS"
#define AMTWPS_FMT	"DRF_XOBJECT_XOBJECT"
#define AMTWPS_MECHFMT	"<"AMTWPS_MECH","AMTWPS_FMT">"
#define AMTWPS_PREFIX	"AMT_"

#endif