#include "xintfld.h"

struct XCONTROLINFO {
	PFNWP prevWndProc;
	XObject* cur;
	int defValue;
	int prevValue;
	int min;
	int max;
	int delta;
	int flags;
	char* buf;
};


MRESULT EXPENTRY wpIntSpinBtnProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2) {
int val;
char *endptr;
XCONTROLINFO* pInfo;
	switch (msg) {
		case WM_AMTINIT:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			switch (SHORT1FROMMP(mp1)) {
				case ID_AMTUNDO:
					val = pInfo->prevValue;
					break;
				case ID_AMTDEFAULT:
					val = pInfo->defValue;
					break;
				case ID_AMTHELP:
				default:
					val = pInfo->cur->getIntValue();
					break;
			}
			WinSendMsg(hwnd, SPBM_SETCURRENTVALUE, &val, NULL);
			break;
		case SPBM_SETCURRENTVALUE:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			val=*(int*)mp1;
			if(pInfo->min<pInfo->max) {
				if(val<pInfo->min) val=pInfo->min;
				if(val>pInfo->max) val=pInfo->max;
			}
			pInfo->cur->setIntValue(val);
			if (!pInfo->buf) pInfo->buf = new char[40];
			itoa(val, pInfo->buf, 10);
			pInfo->prevWndProc(hwnd, SPBM_SETARRAY,&pInfo->buf,MPFROMSHORT(1));
			pInfo->flags = 0;
			break;
		case SPBM_SPINUP:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			WinSendMsg(hwnd, SPBM_QUERYVALUE, &val, NULL);
			val += pInfo->delta;
			WinSendMsg(hwnd, SPBM_SETCURRENTVALUE, &val, NULL);
			return (MRESULT) FALSE;
			break;
		case SPBM_SPINDOWN:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			WinSendMsg(hwnd, SPBM_QUERYVALUE, &val, NULL);
			val -= pInfo->delta;
			WinSendMsg(hwnd, SPBM_SETCURRENTVALUE, &val, NULL);
			return (MRESULT) FALSE;
			break;
		case SPBM_SETLIMITS:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			break;
		case SPBM_QUERYVALUE:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			val = pInfo->cur->getIntValue();
			WinSendMsg(hwnd, SPBM_SETCURRENTVALUE, &val, NULL);
			*(int*)mp1=pInfo->cur->getIntValue();
			break;
		case WM_CHAR:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			pInfo->prevWndProc(hwnd, msg, mp1, mp2);
			if (!pInfo->buf) pInfo->buf = new char[40];
			pInfo->prevWndProc(hwnd, SPBM_QUERYVALUE, (PVOID)pInfo->buf, MPFROM2SHORT(40,SPBQ_DONOTUPDATE));
			pInfo->flags = 1;
			val = strtol(pInfo->buf, &endptr, 0);
			if (!*endptr) {
				if (!(pInfo->min<pInfo->max) || (val>=pInfo->min && val<=pInfo->max)) {
					pInfo->cur->setIntValue(val);
					pInfo->flags = 0;
				}
			}
			break;
		case WM_DESTROY:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			if (pInfo->buf) delete pInfo->buf;
			delete pInfo;
			break;
		case WM_FOCUSCHANGE:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			if(SHORT1FROMMP(mp2)==FALSE && pInfo->flags) {
				WinAlarm(HWND_DESKTOP, WA_ERROR);
				val = pInfo->cur->getIntValue();
				WinSendMsg(hwnd, SPBM_SETCURRENTVALUE, &val, NULL);
//				WinSetFocus(HWND_DESKTOP, hwnd);
			}
			return pInfo->prevWndProc(hwnd, msg, mp1, mp2);
			break;
		default:
			pInfo=(XCONTROLINFO*)WinQueryWindowULong(hwnd, QWL_USER);
			return pInfo->prevWndProc(hwnd, msg, mp1, mp2);
			break;
	}
	return (MRESULT) TRUE;
}

//XIntField----------------------------------
//-------------------------------------------
void	XIntField::initClass() {
	if (getClass(CLASS_INTFIELD_NAME)) return;
	log("IntField::initClass()\n");
	XIntField* o = new XIntField();
	o->addGroupElement(getInstance(CLASS_INT_NAME, OBJECT_VERSION));
	o->addGroupElement(getInstance(CLASS_STRING_NAME, INTFIELD_TITLE, FLAGS_TRANSIENT));
	o->addGroupElement(getInstance(CLASS_INT_NAME, INTFIELD_VALUE));
	o->addGroupElement(getInstance(CLASS_INT_NAME, INTFIELD_MIN, FLAGS_TRANSIENT));
	o->addGroupElement(getInstance(CLASS_INT_NAME, INTFIELD_MAX, FLAGS_TRANSIENT));
	o->addGroupElement(getInstance(CLASS_INT_NAME, INTFIELD_DELTA, FLAGS_TRANSIENT));
	o->getGroupElement(INTFIELD_TITLE)->setStringValue("");
	o->getGroupElement(INTFIELD_DELTA)->setIntValue(1);
	addClass(o, CLASS_INTFIELD_NAME, 0);
}

//-------------------------------------------
XIntField::XIntField() {
	classID = CLASS_GROUP;
	flags = FLAGS_NORMAL;
	ival.lo = ival.hi = 0;
}
XObject*	XIntField::clone() {
	XIntField* o = new XIntField();
	o->copyFrom(this);
	return (XObject*)o;
}
int	XIntField::print(int data) {
	log("IntField::print() %s\n", getName());
	XPRINTINFO* info = (XPRINTINFO*)data;
	prnNewLine(info, info->NormLeading);
	prnSetFont(info, PRN_FONT_NORMAL);
	prnMoveTo(info, 0, PRN_BASE_LEFT, PRN_ALIGN_LEFT);
	prnDrawString(info, getGroupElement(INTFIELD_TITLE)->getStringValue());
	prnMoveTo(info, 0, PRN_BASE_RIGHT, PRN_ALIGN_RIGHT);
	prnDrawInteger(info, getGroupElement(INTFIELD_VALUE)->getIntValue(), 0);
	return 0;
}

int	XIntField::show(int data) {
	log("IntField::show() %s\n", getName());
	XSHOWINFO* info = (XSHOWINFO*)data;
	XCONTROLINFO* cinfo;
	POINTL pt;
	SWP swp;
	ULONG base_ID, base_POS;
	XObject* def = ((XIntField*)info->obj)->getClass()->getGroupElement2(info->varName);
	WinQueryWindowPos(info->hwndWin, &swp);
	winGetNextPos(info->hwndWin, &base_ID, &base_POS);
	HWND w1, w2;
	w1 = WinCreateWindow(info->hwndWin, WC_STATIC, "", WS_VISIBLE|SS_TEXT|DT_BOTTOM|DT_LEFT,
		winMapDlgPoints(info->hwndWin, XWIN_HMARGIN, XWIN_HORIZONTAL), base_POS,
		swp.cx - winMapDlgPoints(info->hwndWin, XWIN_HMARGIN+XWIN_STDWIDTH+XWIN_HSPACE, XWIN_HORIZONTAL), winMapDlgPoints(info->hwndWin, XWIN_STDHEIGHT, XWIN_VERTICAL),
		info->hwndWin, HWND_TOP, base_ID, NULL, NULL);
	WinSetWindowText(w1, getGroupElement(INTFIELD_TITLE)->getStringValue());
	w2 = WinCreateWindow(info->hwndWin, WC_SPINBUTTON, "", WS_VISIBLE | WS_GROUP | WS_TABSTOP | SPBS_JUSTRIGHT,
		swp.cx-winMapDlgPoints(info->hwndWin, XWIN_HMARGIN+XWIN_STDWIDTH, XWIN_HORIZONTAL), base_POS,
		winMapDlgPoints(info->hwndWin, XWIN_STDWIDTH, XWIN_HORIZONTAL), winMapDlgPoints(info->hwndWin, XWIN_STDHEIGHT, XWIN_VERTICAL),
		info->hwndWin, HWND_TOP, base_ID+1, NULL, NULL);
	WinSetPresParam(w1, PP_FONTNAMESIZE, sizeof(XWIN_FONTNAMESIZE), XWIN_FONTNAMESIZE);
	WinSetPresParam(w2, PP_FONTNAMESIZE, sizeof(XWIN_FONTNAMESIZE), XWIN_FONTNAMESIZE);
	cinfo=new XCONTROLINFO;
	memset(cinfo, 0, sizeof(XCONTROLINFO));
	WinSetWindowULong(w2, QWL_USER, (ULONG)cinfo);
	cinfo->cur = getGroupElement(INTFIELD_VALUE);
	cinfo->defValue = (def && def->isObject(getClassName()))?def->getGroupElement(INTFIELD_VALUE)->getIntValue():0;
	cinfo->prevValue = getGroupElement(INTFIELD_VALUE)->getIntValue();
	cinfo->min = getGroupElement(INTFIELD_MIN)->getIntValue();
	cinfo->max = getGroupElement(INTFIELD_MAX)->getIntValue();
	cinfo->delta = getGroupElement(INTFIELD_DELTA)->getIntValue();
	cinfo->prevWndProc = WinSubclassWindow(w2, wpIntSpinBtnProc);

	WinSendMsg(w2, WM_AMTINIT, NULL, NULL);
	return 0;
}